SystemOrganization addCategory: #'A4BP-BPMN20-view'!
SystemOrganization addCategory: 'A4BP-BPMN20-view-Visualization'!

A4BPVCBPProcess subclass: #BPMN20SimpleCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20SimpleCluster methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 3/15/2015 00:44'!
executeVisualization: view
	| v model c |
	v := RTMondrian new.
	v view: view.
	view @ RTDraggableView .
	model := bpObj.
	c := A4BPUIBPModelColorBuilderVisitor new.
	
	"Execute the visulization"
	
	c:= A4BPUIBVFactory colorVisitor.
	v shape circle size:10;color:[:n|n accept:c].
	v nodes: model elements.
	v edges notUseInLayout;
	connectToAll: [:n|n outFlows].
	v layout cluster.
	v build.! !

A4BPVCBPProcess subclass: #BPMN20StandarVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVisualization methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 3/24/2015 17:35'!
executeVisualization: view
	| model cv eb nodes mnodes  |
	view @ RTDraggableView.
	model := bpObj.
	cv:= A4BPUIBVFactory colorVisitor.
	nodes :=  model flowElements.
	"Start the visualization"	
	nodes
		do: [ :el |
			el shape 
				ifNotNil: [ 
					| point es|
					point := el shape bounds x @ el shape bounds y.
					es := (RTBox new 
					width: el shape bounds width;
					height: el shape bounds height;
					color:[:n | n accept:cv];
					elementOn: el) 
					translateTo: point.
					es @ RTDraggable @ RTPopup.
					es when: TRMouseClick do: [ :evt | evt element model inspect ].
					view add: es.
					] 
				].
	"RTNest new for: view elements add: [ :group :esmodel | 
		group add: ((RTLabel new) elementOn: esmodel aName).
		RTGridLayout on: group.
	]."
	
	eb := RTEdgeBuilder new.
	eb view: view.
	eb shape arrowedLine color: Color black.
	eb objects: nodes from: #yourself toAll: [ :e |  e outFlows].
	
	mnodes := model messageFlows.
	eb objects: mnodes from: [ :e |  e sourceRef] to: [ :e |  e targetRef].
	
	eb notUseInLayout.
	view canvas camera focusOnCenterScaled.! !

A4BPVCBPProcess subclass: #BPMN20StandarVisualizationSvg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVisualizationSvg methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 4/11/2015 15:52'!
executeVisualization: view
	| model cv eb nodes mnodes  svgv vizp|
	view @ RTDraggableView.
	model := bpObj.
	cv:= A4BPUIBVFactory colorVisitor.
	svgv := BPMN20IconsSvg new.
	
	nodes :=  model flowElements.
	"Start the visualization"	
	vizp:= BPMN20StandarVizPoint new.
	vizp addBasicElement: view.
	
	model lanes
		do: [ :el |
			el shape 
				ifNotNil: [ 
					| point es|
					point := vizp newp:el.
					es := (RTBox new 
					width: el shape bounds width;
					height: el shape bounds height;
					color:[:n | n accept:cv];
					borderColor: Color black;
					elementOn: el) .
					es translateTo: point.
					es @ RTPopup.
					es when: TRMouseClick do: [ :evt | evt element inspect ].
					view add: es.
					] 
				].
			

	nodes
		do: [ :el |
			el shape 
				ifNotNil: [ 
					| point es|
					point := vizp newp:el.
					es :=  el accept: svgv.
					es color: (el accept:cv).
					es translateTo: point.
					es @ RTDraggable @ RTPopup.
					es when: TRMouseClick do: [ :evt | evt element inspect ].
					view add: es.
					] 
				].

	
	
	eb := RTEdgeBuilder new.
	eb notUseInLayout.
	eb view: view.
	eb shape arrowedLine color: Color black.
	eb objects: nodes from: #yourself toAll: [ :e |  e outFlows].
	mnodes := model messageFlows.
	eb objects: mnodes from: [ :e |  e sourceRef] to: [ :e |  e targetRef].
	view canvas camera focusOnCenterScaled.! !

A4BPUIBPAbstractViewBuilderVisitor subclass: #BPMN20IconsSvg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20IconsSvg methodsFor: 'basic' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 15:10'!
visitA4BPObject: aModel
	| p|
	p := 'm 134.28572,129.50507 125.71428,0 c 26.90858,0 48.57143,21.66285 48.57143,48.57143 l 0,45.71428 c 0,26.90858 -21.66285,48.57143 -48.57143,48.57143 l -125.71428,0 c -26.90858,0 -48.571433,-21.66285 -48.571433,-48.57143 l 0,-45.71428 c 0,-26.90858 21.662853,-48.57143 48.571433,-48.57143 z'.
	^  (RTSVGPath new centeredPath: p; scale: 0.3) elementOn: aModel.! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20ComplexGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 14:05'!
visitBPMN20EndEventImpl: aModel
	| p scale|
	p := 'm 86.873964,113.25507 21.609226,0 c 36.75139,0 66.33825,29.58687 66.33825,66.33826 l 0,11.60919 c 0,36.7514 -29.58686,66.33826 -66.33825,66.33826 l -21.609226,0 c -36.751394,0 -66.338257,-29.58686 -66.338257,-66.33826 l 0,-11.60919 c 0,-36.75139 29.586863,-66.33826 66.338257,-66.33826 z'.
	scale := aModel shape bounds width / 200.
	^  (RTSVGPath new centeredPath: p; scale: scale) elementOn: aModel.! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20EventBasedGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20ExclusiveGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 15:11'!
visitBPMN20GatewayImpl: aModel
	| p scale|
	p := 'm -68.318504,177.5455 80,0 c 5.54,0 10,4.46 10,10 l 0,80 c 0,5.54 -4.46,10 -10,10 l -80,0 c -5.54,0 -10,-4.46 -10,-10 l 0,-80 c 0,-5.54 4.46,-10 10,-10 z'.
	"scale := aModel shape bounds width / 100."
	scale := 0.3.
	^  (RTSVGPath new centeredPath: p; scale: scale ; rotate:45) elementOn: aModel.! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20InclusiveGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 10:06'!
visitBPMN20IntermediateThrowEventImpl: aModel
	| p scale|
	p := 'm 134.28572,129.50507 125.71428,0 c 26.90858,0 48.57143,21.66285 48.57143,48.57143 l 0,45.71428 c 0,26.90858 -21.66285,48.57143 -48.57143,48.57143 l -125.71428,0 c -26.90858,0 -48.571433,-21.66285 -48.571433,-48.57143 l 0,-45.71428 c 0,-26.90858 21.662853,-48.57143 48.571433,-48.57143 z'.
	scale := aModel shape bounds width / 400.
	^  (RTSVGPath new centeredPath: p; scale: scale) elementOn: aModel.! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:43'!
visitBPMN20ParallelGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 14:05'!
visitBPMN20StartEventImpl: aModel
	| p scale|
	p := 'm 86.873964,113.25507 21.609226,0 c 36.75139,0 66.33825,29.58687 66.33825,66.33826 l 0,11.60919 c 0,36.7514 -29.58686,66.33826 -66.33825,66.33826 l -21.609226,0 c -36.751394,0 -66.338257,-29.58686 -66.338257,-66.33826 l 0,-11.60919 c 0,-36.75139 29.586863,-66.33826 66.338257,-66.33826 z'.
	scale := aModel shape bounds width / 200.
	^  (RTSVGPath new centeredPath: p; scale: scale) elementOn: aModel.! !

!BPMN20IconsSvg methodsFor: 'activities' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 15:11'!
visitBPMN20TaskImpl: aModel
	| p scale|
	p := 'm 134.28572,129.50507 125.71428,0 c 26.90858,0 48.57143,21.66285 48.57143,48.57143 l 0,45.71428 c 0,26.90858 -21.66285,48.57143 -48.57143,48.57143 l -125.71428,0 c -26.90858,0 -48.571433,-21.66285 -48.571433,-48.57143 l 0,-45.71428 c 0,-26.90858 21.662853,-48.57143 48.571433,-48.57143 z'.
	"scale := aModel shape bounds width / 400."
	scale := 0.3.
	^  (RTSVGPath new centeredPath: p; scale: scale) elementOn: aModel.! !

Object subclass: #BPMN20StandarVizPoint
	instanceVariableNames: 'ww hh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVizPoint methodsFor: 'initalize' stamp: 'AlvaroJosePeraltaOcampo 3/27/2015 20:51'!
addBasicElement: view
	|box|
	box := RTBox new width: ww ;height: hh ; color: (Color lightGray alpha:0.01); elementOn:''.
	box translateTo:0@0.
	view add: box.! !

!BPMN20StandarVizPoint methodsFor: 'initalize' stamp: 'AlvaroJosePeraltaOcampo 3/27/2015 20:51'!
initialize
	super initialize.
	ww:= 2000.
	hh:= 2000.
	! !

!BPMN20StandarVizPoint methodsFor: 'initalize' stamp: 'AlvaroJosePeraltaOcampo 3/27/2015 18:56'!
newp: el
	|point w h x y|
	w := el shape bounds width.
	h :=  el shape bounds height.
	x := el shape bounds x.
	y := el shape bounds y.
	point := ( (w/2) - ( ww / 2 ) + x ) @ ( (h) - (hh/2)- (h/2) + y ).
	^ point! !

!A4BPVCBuilder methodsFor: '*A4BP-BPMN20-view-Visualization' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:47'!
visitBPMN20Object: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	A4BPVCBuilder subclasses
		do: [ :c | 
			|builder|
			builder := c new.
			visualizations addAll: (aModel accept: builder) ].
	^ visualizations! !

A4BPVCBuilder subclass: #BPMN20VCBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/26/2015 09:39'!
visitBPMN20DefinitionsImpl: aModel
	| visualizations bpvc|
	visualizations := OrderedCollection new.
	self setVisualizationForAllModel: visualizations inModel: aModel.
	bpvc := BPMN20StandarVisualizationSvg new bpObj: aModel.
	visualizations add: bpvc.
	
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:49'!
visitBPMN20Object: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/26/2015 09:39'!
visitBPMN20ProcessImpl: aModel
	| visualizations bpvc|
	visualizations := self visitBPProcess: aModel.

	bpvc := BPMN20SimpleCluster new bpObj: aModel.
	visualizations add: bpvc.

	bpvc := BPMN20StandarVisualizationSvg new bpObj: aModel.
	visualizations add: bpvc.
	^ visualizations! !
